package io.lemniscat.sabacc.domain.model

import io.lemniscat.sabacc.domain.model.card.*
import org.assertj.core.api.Assertions.*
import org.junit.jupiter.api.Test
import kotlin.random.Random

val ORDERED_CARDS = listOf(
        SuitCard(StandardSuit.Sabers, SuitValue.ONE),
        SuitCard(StandardSuit.Sabers, SuitValue.TWO),
        SuitCard(StandardSuit.Sabers, SuitValue.THREE),
        SuitCard(StandardSuit.Sabers, SuitValue.FOUR),
        SuitCard(StandardSuit.Sabers, SuitValue.FIVE),
        SuitCard(StandardSuit.Sabers, SuitValue.SIX),
        SuitCard(StandardSuit.Sabers, SuitValue.SEVEN),
        SuitCard(StandardSuit.Sabers, SuitValue.EIGHT),
        SuitCard(StandardSuit.Sabers, SuitValue.NINE),
        SuitCard(StandardSuit.Sabers, SuitValue.TEN),
        SuitCard(StandardSuit.Sabers, SuitValue.ELEVEN),
        SuitCard(StandardSuit.Sabers, SuitValue.COMMANDER),
        SuitCard(StandardSuit.Sabers, SuitValue.MISTRESS),
        SuitCard(StandardSuit.Sabers, SuitValue.MASTER),
        SuitCard(StandardSuit.Sabers, SuitValue.ACE),
        SuitCard(StandardSuit.Flasks, SuitValue.ONE),
        SuitCard(StandardSuit.Flasks, SuitValue.TWO),
        SuitCard(StandardSuit.Flasks, SuitValue.THREE),
        SuitCard(StandardSuit.Flasks, SuitValue.FOUR),
        SuitCard(StandardSuit.Flasks, SuitValue.FIVE),
        SuitCard(StandardSuit.Flasks, SuitValue.SIX),
        SuitCard(StandardSuit.Flasks, SuitValue.SEVEN),
        SuitCard(StandardSuit.Flasks, SuitValue.EIGHT),
        SuitCard(StandardSuit.Flasks, SuitValue.NINE),
        SuitCard(StandardSuit.Flasks, SuitValue.TEN),
        SuitCard(StandardSuit.Flasks, SuitValue.ELEVEN),
        SuitCard(StandardSuit.Flasks, SuitValue.COMMANDER),
        SuitCard(StandardSuit.Flasks, SuitValue.MISTRESS),
        SuitCard(StandardSuit.Flasks, SuitValue.MASTER),
        SuitCard(StandardSuit.Flasks, SuitValue.ACE),
        SuitCard(StandardSuit.Coins, SuitValue.ONE),
        SuitCard(StandardSuit.Coins, SuitValue.TWO),
        SuitCard(StandardSuit.Coins, SuitValue.THREE),
        SuitCard(StandardSuit.Coins, SuitValue.FOUR),
        SuitCard(StandardSuit.Coins, SuitValue.FIVE),
        SuitCard(StandardSuit.Coins, SuitValue.SIX),
        SuitCard(StandardSuit.Coins, SuitValue.SEVEN),
        SuitCard(StandardSuit.Coins, SuitValue.EIGHT),
        SuitCard(StandardSuit.Coins, SuitValue.NINE),
        SuitCard(StandardSuit.Coins, SuitValue.TEN),
        SuitCard(StandardSuit.Coins, SuitValue.ELEVEN),
        SuitCard(StandardSuit.Coins, SuitValue.COMMANDER),
        SuitCard(StandardSuit.Coins, SuitValue.MISTRESS),
        SuitCard(StandardSuit.Coins, SuitValue.MASTER),
        SuitCard(StandardSuit.Coins, SuitValue.ACE),
        SuitCard(StandardSuit.Staves, SuitValue.ONE),
        SuitCard(StandardSuit.Staves, SuitValue.TWO),
        SuitCard(StandardSuit.Staves, SuitValue.THREE),
        SuitCard(StandardSuit.Staves, SuitValue.FOUR),
        SuitCard(StandardSuit.Staves, SuitValue.FIVE),
        SuitCard(StandardSuit.Staves, SuitValue.SIX),
        SuitCard(StandardSuit.Staves, SuitValue.SEVEN),
        SuitCard(StandardSuit.Staves, SuitValue.EIGHT),
        SuitCard(StandardSuit.Staves, SuitValue.NINE),
        SuitCard(StandardSuit.Staves, SuitValue.TEN),
        SuitCard(StandardSuit.Staves, SuitValue.ELEVEN),
        SuitCard(StandardSuit.Staves, SuitValue.COMMANDER),
        SuitCard(StandardSuit.Staves, SuitValue.MISTRESS),
        SuitCard(StandardSuit.Staves, SuitValue.MASTER),
        SuitCard(StandardSuit.Staves, SuitValue.ACE),
        FaceCard(FaceSuit.Black, FaceValue.STAR),
        FaceCard(FaceSuit.Black, FaceValue.EVIL_ONE),
        FaceCard(FaceSuit.Black, FaceValue.MODERATION),
        FaceCard(FaceSuit.Black, FaceValue.DEMISE),
        FaceCard(FaceSuit.Black, FaceValue.BALANCE),
        FaceCard(FaceSuit.Black, FaceValue.ENDURANCE),
        FaceCard(FaceSuit.Black, FaceValue.QUEEN_OF_AIR_AND_DARKNESS),
        FaceCard(FaceSuit.Black, FaceValue.IDIOT)
)

val RANDOMIZED_CARDS = listOf(
        SuitCard.of(StandardSuit.Sabers, SuitValue.SIX),
        SuitCard.of(StandardSuit.Sabers, SuitValue.TEN),
        SuitCard.of(StandardSuit.Sabers, SuitValue.ONE),
        FaceCard.of(FaceSuit.White, FaceValue.EVIL_ONE),
        SuitCard.of(StandardSuit.Coins, SuitValue.FIVE),
        SuitCard.of(StandardSuit.Flasks, SuitValue.FIVE),
        FaceCard.of(FaceSuit.White, FaceValue.ENDURANCE),
        SuitCard.of(StandardSuit.Staves, SuitValue.FIVE),
        SuitCard.of(StandardSuit.Coins, SuitValue.TEN),
        SuitCard.of(StandardSuit.Coins, SuitValue.THREE),
        SuitCard.of(StandardSuit.Staves, SuitValue.ACE),
        SuitCard.of(StandardSuit.Sabers, SuitValue.EIGHT),
        FaceCard.of(FaceSuit.Black, FaceValue.STAR),
        SuitCard.of(StandardSuit.Sabers, SuitValue.TWO),
        SuitCard.of(StandardSuit.Coins, SuitValue.ACE),
        SuitCard.of(StandardSuit.Coins, SuitValue.TWO),
        SuitCard.of(StandardSuit.Staves, SuitValue.ONE),
        SuitCard.of(StandardSuit.Flasks, SuitValue.MISTRESS),
        SuitCard.of(StandardSuit.Sabers, SuitValue.ACE),
        SuitCard.of(StandardSuit.Staves, SuitValue.MISTRESS),
        SuitCard.of(StandardSuit.Coins, SuitValue.ELEVEN),
        SuitCard.of(StandardSuit.Sabers, SuitValue.MISTRESS),
        FaceCard.of(FaceSuit.Black, FaceValue.EVIL_ONE),
        SuitCard.of(StandardSuit.Coins, SuitValue.EIGHT),
        SuitCard.of(StandardSuit.Flasks, SuitValue.SEVEN),
        SuitCard.of(StandardSuit.Sabers, SuitValue.NINE),
        SuitCard.of(StandardSuit.Flasks, SuitValue.MASTER),
        SuitCard.of(StandardSuit.Sabers, SuitValue.MASTER),
        SuitCard.of(StandardSuit.Coins, SuitValue.ONE),
        SuitCard.of(StandardSuit.Staves, SuitValue.MASTER),
        SuitCard.of(StandardSuit.Flasks, SuitValue.COMMANDER),
        SuitCard.of(StandardSuit.Coins, SuitValue.SEVEN),
        SuitCard.of(StandardSuit.Coins, SuitValue.SIX),
        SuitCard.of(StandardSuit.Staves, SuitValue.THREE),
        FaceCard.of(FaceSuit.White, FaceValue.STAR),
        FaceCard.of(FaceSuit.Black, FaceValue.IDIOT),
        SuitCard.of(StandardSuit.Staves, SuitValue.FOUR),
        SuitCard.of(StandardSuit.Coins, SuitValue.MISTRESS),
        SuitCard.of(StandardSuit.Sabers, SuitValue.FIVE),
        FaceCard.of(FaceSuit.White, FaceValue.DEMISE),
        SuitCard.of(StandardSuit.Sabers, SuitValue.ELEVEN),
        FaceCard.of(FaceSuit.White, FaceValue.QUEEN_OF_AIR_AND_DARKNESS),
        FaceCard.of(FaceSuit.Black, FaceValue.ENDURANCE),
        SuitCard.of(StandardSuit.Coins, SuitValue.COMMANDER),
        SuitCard.of(StandardSuit.Coins, SuitValue.FOUR),
        SuitCard.of(StandardSuit.Flasks, SuitValue.NINE),
        SuitCard.of(StandardSuit.Flasks, SuitValue.THREE),
        SuitCard.of(StandardSuit.Staves, SuitValue.SEVEN),
        FaceCard.of(FaceSuit.Black, FaceValue.QUEEN_OF_AIR_AND_DARKNESS),
        SuitCard.of(StandardSuit.Flasks, SuitValue.ACE),
        FaceCard.of(FaceSuit.White, FaceValue.MODERATION),
        FaceCard.of(FaceSuit.Black, FaceValue.BALANCE),
        FaceCard.of(FaceSuit.White, FaceValue.BALANCE),
        FaceCard.of(FaceSuit.Black, FaceValue.DEMISE),
        SuitCard.of(StandardSuit.Staves, SuitValue.ELEVEN),
        SuitCard.of(StandardSuit.Flasks, SuitValue.EIGHT),
        FaceCard.of(FaceSuit.Black, FaceValue.MODERATION),
        SuitCard.of(StandardSuit.Coins, SuitValue.NINE),
        SuitCard.of(StandardSuit.Flasks, SuitValue.FOUR),
        SuitCard.of(StandardSuit.Staves, SuitValue.SIX),
        SuitCard.of(StandardSuit.Flasks, SuitValue.ELEVEN),
        SuitCard.of(StandardSuit.Coins, SuitValue.MASTER),
        SuitCard.of(StandardSuit.Flasks, SuitValue.ONE),
        SuitCard.of(StandardSuit.Staves, SuitValue.EIGHT),
        SuitCard.of(StandardSuit.Sabers, SuitValue.COMMANDER),
        SuitCard.of(StandardSuit.Sabers, SuitValue.SEVEN),
        SuitCard.of(StandardSuit.Staves, SuitValue.TEN),
        SuitCard.of(StandardSuit.Sabers, SuitValue.THREE),
        FaceCard.of(FaceSuit.White, FaceValue.IDIOT),
        SuitCard.of(StandardSuit.Flasks, SuitValue.SIX),
        SuitCard.of(StandardSuit.Flasks, SuitValue.TEN),
        SuitCard.of(StandardSuit.Staves, SuitValue.NINE),
        SuitCard.of(StandardSuit.Staves, SuitValue.TWO),
        SuitCard.of(StandardSuit.Flasks, SuitValue.TWO),
        SuitCard.of(StandardSuit.Sabers, SuitValue.FOUR),
        SuitCard.of(StandardSuit.Staves, SuitValue.COMMANDER)
)

class DeckTests {
    @Test
    fun `When shuffled, a deck should have its cards in a random order`() {
        assertThat(Deck.shuffle(Random(13)).cards).containsExactly(*RANDOMIZED_CARDS.toTypedArray())
    }

    @Test
    fun `When shuffled, a deck should have one card of each`() {
        val shuffledDeck = Deck.shuffle()
        assertThat(shuffledDeck.size).isEqualTo(ORDERED_CARDS.size)
        assertThat(shuffledDeck.cards).containsExactlyInAnyOrder(*ORDERED_CARDS.toTypedArray())
    }
}